#include "Dialog.h"

#define EXIT_DIALOG_WIDTH_ 36
#define EXIT_DIALOG_HEIGHT_ 20
#define EXIT_DIALOG_X_ 22
#define DIALOG_Y_ 44
#define DIALOG_Y_TEXT_ 45

#define ARTEFACT_PIECE_DIALOG_X_ 29
#define ARTEFACT_PIECE_DIALOG_WIDTH_ 14
#define ARTEFACT_PIECE_DIALOG_HEIGHT_ 34

u8 exitDialog()
{
    u8* memory = cpctm_screenPtr(CPCT_VMEM_START, EXIT_DIALOG_X_, DIALOG_Y_);
    cpct_drawSolidBox(memory, cpctm_px2byteM0(0, 0) , EXIT_DIALOG_WIDTH_, EXIT_DIALOG_HEIGHT_ );
    drawString(EXIT_DIALOG_X_ + 1, DIALOG_Y_TEXT_ + 3, "exit       y or n");

    // Break out of the loop once the user decides on their choice.
    return yesNoChoice();
}

void artefactPieceDialog()
{
    static u8 objectiveText[3];

    // Draw the dialog box for objectives.
    u8* memory = cpctm_screenPtr(CPCT_VMEM_START, ARTEFACT_PIECE_DIALOG_X_, DIALOG_Y_);
    cpct_drawSolidBox(memory, cpctm_px2byteM0(0, 0), ARTEFACT_PIECE_DIALOG_WIDTH_, ARTEFACT_PIECE_DIALOG_HEIGHT_);
    drawString(ARTEFACT_PIECE_DIALOG_X_ + 1, DIALOG_Y_TEXT_, "pieces");

    // Display the number of objective actions remaining.
    convertNumberToString(remainingArtefactPieces, objectiveText);
    drawString(ARTEFACT_PIECE_DIALOG_X_ + 9, DIALOG_Y_TEXT_ + 18, objectiveText);

    // Display artefact (staff) piece graphic.
    cpct_drawSprite(G_item_staff_middle, memory + 162, TILE_WIDTH_BYTES, TILE_HEIGHT);

    // Wait for any previous key presses to clear first.
    while (cpct_isAnyKeyPressed());

    // Then wait for another key press.
    while (!cpct_isAnyKeyPressed());

    // Redraw map and player after finishing with objective dialog.
    mapRedraw = TRUE;
    player.redraw = TRUE;
}

u8 restoreDialog()
{
    u8* memory = cpctm_screenPtr(CPCT_VMEM_START, EXIT_DIALOG_X_, DIALOG_Y_);
    cpct_drawSolidBox(memory, cpctm_px2byteM0(0, 0), EXIT_DIALOG_WIDTH_, EXIT_DIALOG_HEIGHT_);
    drawString(EXIT_DIALOG_X_ + 1, DIALOG_Y_TEXT_ + 3, "restore    y or n");

    // Break out of the loop once the user decides on their choice.
    return yesNoChoice();
}

u8 yesNoChoice()
{
    // Break out of the loop once the user decides on their choice.
    while (1)
    {
        if (cpct_isKeyPressed(Key_Y))
        {
            return TRUE;
        }
        else if (cpct_isKeyPressed(Key_N))
        {
            return FALSE;
        }
    }
}