#include "Difficulty.h"

// The difficulty level chosen by the player for the game session.
u8 chosenDifficulty = 0;

// The amount of lives the player starts with.
u8 startingLivesCount = 3;

// The number of hit points restored by a health item.
u8 healthItemAmount = 3;

// The number of hit points that the player starts with.
u8 playerStartingHealth = 8;

// The maximum amount of hit points that the player can have.
u8 maxPlayerHealth = 15;

// The amount of health the player loses on colliding with a spike.
u8 spikeDamageAmount = 3;

// The number of arrows in an arrow item on pickup.
u8 arrowPickupCount = 3;

// The number of seconds to add to the game time on pickup of hourglass item.
u8 hourglassTime = 30;

// Indicates whether checkpoints are active or not.
u8 checkpointsActive = TRUE;

void setupDifficulty()
{
    healthItemAmount = 3;
    playerStartingHealth = 8;
    maxPlayerHealth = 15;
    spikeDamageAmount = 3;
    arrowPickupCount = 3;
    hourglassTime = 38;
    startingLivesCount = 4;
    checkpointsActive = TRUE;

    if (chosenDifficulty <= EASY_DIFFICULTY)
    {
        startingLivesCount = 5;
        healthItemAmount = 4;
        maxPlayerHealth = 20;
        spikeDamageAmount = 2;

        // More time for on easy (consider it rounded up from 46).
        hourglassTime = 50;

        if (chosenDifficulty == PRACTICE_DIFFICULTY)
        {
            // Significantly more time for practice difficulty (double easy).
            hourglassTime = 100;
        }
    }
    else if (chosenDifficulty == HARD_DIFFICULTY)
    {
        // Normal and hard are mostly the same except hard does not have checkpoints.
        checkpointsActive = FALSE;

        // Originally normal was 3 but this was moved to hard when normal was changed to 4 and easy to 5.
        startingLivesCount = 3;

        // Originally normal was 30 but this was moved to hard when normal was changed to 38.
        hourglassTime = 30;
    }
    else if (chosenDifficulty == BRUTAL_DIFFICULTY)
    {
        startingLivesCount = 2;
        healthItemAmount = 2;
        maxPlayerHealth = 10;
        spikeDamageAmount = 4;
        checkpointsActive = FALSE;
        hourglassTime = 22;
    }
}