#ifndef DIFFICULTY_H
#define DIFFICULTY_H

#include <types.h>
#include "GameTypes.h"

// Game difficulty options.
#define PRACTICE_DIFFICULTY 0
#define EASY_DIFFICULTY 1
#define NORMAL_DIFFICULTY 2
#define HARD_DIFFICULTY 3
#define BRUTAL_DIFFICULTY 4

// The difficulty level chosen by the player for the game session.
extern u8 chosenDifficulty;

// The amount of lives the player starts with.
extern u8 startingLivesCount;

// The number of hit points restored by a health item.
extern u8 healthItemAmount;

// The number of hit points that the player starts with.
extern u8 playerStartingHealth;

// The maximum amount of hit points that the player can have.
extern u8 maxPlayerHealth;

// The amount of health the player loses on colliding with a spike.
extern u8 spikeDamageAmount;

// The number of arrows in an arrow item on pickup.
extern u8 arrowPickupCount;

// The number of seconds to add to the game time on pickup of hourglass item.
extern u8 hourglassTime;

// Indicates whether checkpoints are active or not.
extern u8 checkpointsActive;

// Sets up all the difficulty values for the game session.
void setupDifficulty();

#endif