#ifndef ENVRIONMENT_H
#define ENVIRONMENT_H

#include <types.h>
#include "Interrupt.h"
#include "Map.h"
#include "Player.h"

#define ENVIRONMENT_LAVA_STONES 1
#define ENVIRONMENT_SAND 2
#define ENVIRONMENT_SAND2 3
#define ENVIRONMENT_GRASS 4
#define ENVIRONMENT_GRASS2 5
#define ENVIRONMENT_FLOWERS 6
#define ENVIRONMENT_CRUMBLING_BLOCK_5 7
#define ENVIRONMENT_CRUMBLING_BLOCK_4 8
#define ENVIRONMENT_CRUMBLING_BLOCK_3 9
#define ENVIRONMENT_CRUMBLING_BLOCK_2 10
#define ENVIRONMENT_CRUMBLING_BLOCK_1 11
#define ENVIRONMENT_HIDDEN_TRIGGER 12
#define ENVIRONMENT_WALL_FLOW 13
#define ENVIRONMENT_WATER_FLOW 14
#define ENVIRONMENT_TRAPDOOR_TARGET 15
#define ENVIRONMENT_LAVA_FLOW 16
#define ENVIRONMENT_GATE_OPEN 17
#define ENVIRONMENT_DANGEROUS_PLANT 18
#define ENVIRONMENT_DANGEROUS_PLANT_WATER 19
#define ENVIRONMENT_CHASM 20
#define ENVIRONMENT_LAVA 21
#define ENVIRONMENT_WATER 22
#define ENVIRONMENT_TURRET_LEFT 23
#define ENVIRONMENT_TURRET_RIGHT 24
#define ENVIRONMENT_TURRET_UP 25
#define ENVIRONMENT_TURRET_DOWN 26
#define ENVIRONMENT_HEDGE_0 27
#define ENVIRONMENT_HEDGE_1 28
#define ENVIRONMENT_HEDGE_2 29
#define ENVIRONMENT_HIDDEN_SOLID 30

// Queues the specified cell for crumbling onto the crumbling queue and triggers the crumbling timer.
void crumbleBlock(u8 x, u8 y, u8 roomX, u8 roomY);

// Transitions a crumbling environment cells through the various crumbling stages.
void transitionCrumblingBlock();

// Converts the source flow cells to destination cells.
void triggerFlow(u8 x, u8 y, u8 roomX, u8 roomY, u8 sourceCell, u8 destinationCell);

// Attempts to add the map cell index to the queue and returns the queue index.
u8 queueItem(u16 mapCellIndex);

// Initialises the crumble queue values to empty (EMPTY_QUEUE_ITEM).
void initCrumbleQueue();

// Starts the hedge timer that the player must wait for in order to transition a hedge cell.
void startHedgeTimer(u8 x, u8 y, u8 roomX, u8 roomY);

// Updates the current hedge cell to the next state in the hedge cycle.
void updateHedgeCell();

// Stops the hedge timer and clears the blended sprite used for showing when the player is using the machete.
void stopHedgeTimer();

#endif