#include "GameState.h"

// Indicates if the game is currently running within the game loop.
u8 gameRunning = FALSE;

// The score for the whole game session.
u16 gameScore = 0;

// The score including the progress for the current level.
u16 levelScore = 0;

// The current room that the player is in (0 to 8).
u8 currentRoom = 0;

// The current room (x coordinate within the grid).
u8 currentRoomX = 0;

// The current room (y coordinate within the grid).
u8 currentRoomY = 0;

// Indicates the player has recently changed rooms.
u8 roomChange = FALSE;

// Indicates the state of the level (or game) and whether it has ended (including success or failure).
u8 levelState = LEVEL_READY;

// The number of lives that the player has.
u8 playerLives = 0;

// The number of seconds remaining in the level.
u8 levelTimerSecondsRemaining = 0;

// Indicates whether the level timer is enabled and displaying on screen.
u8 enableLevelTimer = FALSE;

// The current identifier value used to uniquely identify actors within the game.
u8 currentId = 1;

// Indicates whether the game was started using a pass code.
u8 passcodeUsed = FALSE;

// The number of coins the player has collected in the game.
u8 coinCount = 0;

// The X position (of the whole map) of the current checkpoint that the player has saved.
u8 checkpointX = 255;

// The Y position (of the whole map) of the current checkpoint that the player has saved.
u8 checkpointY = 255;

// Indicates whether the restore dialog should be shown when restoring last checkpoint.
u8 showRestoreDialog = FALSE;

void resetGameSessionState()
{
    gameScore = 0;
    levelScore = 0;
    roomChange = FALSE;
    levelState = LEVEL_READY;
    coinCount = 0;
    showRestoreDialog = FALSE;

    // Initialise checkpoint to 255 which means it is not set.
    checkpointX = 255;
    checkpointY = 255;

    // Initialise to 1 so that 0 can be used as an unset value if necessary.
    currentId = 1;

    // Sets the difficulty values for the game based on player chosen difficulty.
    setupDifficulty();

    // Difficulty must be set before setting player lives.
    playerLives = startingLivesCount;
}