#ifndef INTERRUPT_H
#define INTERRUPT_H

#include <cpctelera.h>
#include "Environment.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Sound.h"

// The current count of the collision timer when the player is invincible due to an enemy collision.
extern u16 collisionTimerCount;

// Indicates that the collision timer is active.
extern u8 collisionActive;

// The current count of the crumbling block timer used for transitioning between crumbling environment blocks.
extern u16 crumblingTimerCount;

// Indicates that the crumbling timer is active.
extern u8 crumblingTimerActive;

// The current count of the hedge timer used for transitioning between hedge states.
extern u16 hedgeTimerCount;

// Indicates that the hedge timer is active.
extern u8 hedgeTimerActive;

// Actions to run when an interrupts occur.
void interruptHandler();

// Activate the player invincibility collision timer.
void activateCollisionTimer();

#endif