#ifndef INVENTORY_H
#define INVENTORY_H

#include <types.h>
#include "Item.h"

#define INVENTORY_ITEM_KEY_RED 1
#define INVENTORY_ITEM_KEY_GREEN 2
#define INVENTORY_ITEM_KEY_YELLOW 4
#define INVENTORY_ITEM_BLOCK 8
#define INVENTORY_ITEM_BOW 16
#define INVENTORY_ITEM_GLASSES 32
#define INVENTORY_ITEM_MACHETE 64
#define INVENTORY_ITEM_FINS 128

// Inventory flags that define what inventory the player is carrying and will be displayed on the hud.
extern u8 inventoryItems;

// Adds a specified item to the inventory from a given cell graphic value without flags.
void addItemToInventory(u8 item);

// Checks if the inventory contains the specified item type.
u8 inventoryContainsItem(u8 item);

#endif