#include "Keys.h"

// Player selected controls for movement and actions.
Keys gameControls;

// Indicates whether the use key is currently pressed.
u8 useKeyFlag;

void initKeys()
{
    gameControls.controlFlags = 0;
    useKeyFlag = FALSE;
}

void setDefaultKeys()
{
    gameControls.left = Key_CursorLeft;
    gameControls.right = Key_CursorRight;
    gameControls.up = Key_CursorUp;
    gameControls.down = Key_CursorDown;
    gameControls.exit = Key_Esc;
    gameControls.use = Key_X;
}

void readGameControls()
{
    if (cpct_isKeyPressed(gameControls.up))
    {
        gameControls.controlFlags |= CONTROL_UP_FLAG;
    }
    else
    {
        gameControls.controlFlags &= ~CONTROL_UP_FLAG;
    }

    if (cpct_isKeyPressed(gameControls.down))
    {
        gameControls.controlFlags |= CONTROL_DOWN_FLAG;
    }
    else
    {
        gameControls.controlFlags &= ~CONTROL_DOWN_FLAG;
    }

    if (cpct_isKeyPressed(gameControls.left))
    {
        gameControls.controlFlags |= CONTROL_LEFT_FLAG;
    }
    else
    {
        gameControls.controlFlags &= ~CONTROL_LEFT_FLAG;
    }

    if (cpct_isKeyPressed(gameControls.right))
    {
        gameControls.controlFlags |= CONTROL_RIGHT_FLAG;
    }
    else
    {
        gameControls.controlFlags &= ~CONTROL_RIGHT_FLAG;
    }

    if (cpct_isKeyPressed(gameControls.use))
    {
        gameControls.controlFlags |= CONTROL_USE_FLAG;
    }
    else
    {
        gameControls.controlFlags &= ~CONTROL_USE_FLAG;

        // Use flag can be reset now that player is no longer pressing use key.
        useKeyFlag = FALSE;
    }

    if (cpct_isKeyPressed(gameControls.exit))
    {
        gameControls.controlFlags |= CONTROL_EXIT_FLAG;
    }
    else
    {
        gameControls.controlFlags &= ~CONTROL_EXIT_FLAG;
    }
}