#ifndef KEYS_H
#define KEYS_H

#include <cpctelera.h>
#include "GameTypes.h"

// Control flag for up key detection.
#define CONTROL_UP_FLAG 1

// Control flag for down key detection.
#define CONTROL_DOWN_FLAG 2

// Control flag for left key detection.
#define CONTROL_LEFT_FLAG 4

// Control flag for right key detection.
#define CONTROL_RIGHT_FLAG 8

// Control flag for use key detection.
#define CONTROL_USE_FLAG 16

// Control flag for exit key detection.
#define CONTROL_EXIT_FLAG 64

typedef struct Keys Keys;

// Defines the controls used in the game.
struct Keys
{
    // Key values for setting custom controls.
    cpct_keyID up;
    cpct_keyID down;
    cpct_keyID left;
    cpct_keyID right;
    cpct_keyID use;
    cpct_keyID exit;

    // Flags indicating what controls are down.
    u8 controlFlags;
};

// Player selected controls for movement and actions.
extern Keys gameControls;

// Indicates whether the use key is currently pressed.
extern u8 useKeyFlag;

// Initialises key values to ensure that no keys are currently pressed at the start of the game.
void initKeys();

// Sets the default player controls for the game (if the user does not customise the controls).
void setDefaultKeys();

// Update the controls flags based on the keys that are currently pressed down.
void readGameControls();

#endif