#include "MapManager.h"

u8* const level_map[LEVEL_COUNT] =
{
    map_IntroLevel_compressed,
    map_SwitchesLevel_compressed,
    map_TeleportersLevel_compressed,
    map_IslandLevel_compressed,
    map_HedgeMazeLevel_compressed,
    map_LavaIslandLevel_compressed
};

const u16 level_map_size[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_COMPRESSED_SIZE,
    MAP_SWITCHESLEVEL_COMPRESSED_SIZE,
    MAP_TELEPORTERSLEVEL_COMPRESSED_SIZE,
    MAP_ISLANDLEVEL_COMPRESSED_SIZE,
    MAP_HEDGEMAZELEVEL_COMPRESSED_SIZE,
    MAP_LAVAISLANDLEVEL_COMPRESSED_SIZE
};

u8* const level_links[LEVEL_COUNT] =
{
    NULL,
    map_SwitchesLevel_links,
    map_TeleportersLevel_links,
    NULL,
    map_HedgeMazeLevel_links,
    map_LavaIslandLevel_links
};

const u8 level_links_array_size[LEVEL_COUNT] =
{
    0,
    MAP_SWITCHESLEVEL_LINK_ARRAY_SIZE,
    MAP_TELEPORTERSLEVEL_LINK_ARRAY_SIZE,
    0,
    MAP_HEDGEMAZELEVEL_LINK_ARRAY_SIZE,
    MAP_LAVAISLANDLEVEL_LINK_ARRAY_SIZE
};

u8* const level_start_position[LEVEL_COUNT] =
{
    map_IntroLevel_startPosition,
    map_SwitchesLevel_startPosition,
    map_TeleportersLevel_startPosition,
    map_IslandLevel_startPosition,
    map_HedgeMazeLevel_startPosition,
    map_LavaIslandLevel_startPosition
};

const u8 level_default_environment_cell[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_DEFAULT_ENVIRONMENT_CELL,
    MAP_SWITCHESLEVEL_DEFAULT_ENVIRONMENT_CELL,
    MAP_TELEPORTERSLEVEL_DEFAULT_ENVIRONMENT_CELL,
    MAP_ISLANDLEVEL_DEFAULT_ENVIRONMENT_CELL,
    MAP_HEDGEMAZELEVEL_DEFAULT_ENVIRONMENT_CELL,
    MAP_LAVAISLANDLEVEL_DEFAULT_ENVIRONMENT_CELL
};

const u8 level_clear_cell[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_DEFAULT_CLEAR_CELL,
    MAP_SWITCHESLEVEL_DEFAULT_CLEAR_CELL,
    MAP_TELEPORTERSLEVEL_DEFAULT_CLEAR_CELL,
    MAP_ISLANDLEVEL_DEFAULT_CLEAR_CELL,
    MAP_HEDGEMAZELEVEL_DEFAULT_CLEAR_CELL,
    MAP_LAVAISLANDLEVEL_DEFAULT_CLEAR_CELL
};

const u8 level_map_time[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_MAP_TIME,
    MAP_SWITCHESLEVEL_MAP_TIME,
    MAP_TELEPORTERSLEVEL_MAP_TIME,
    MAP_ISLANDLEVEL_MAP_TIME,
    MAP_HEDGEMAZELEVEL_MAP_TIME,
    MAP_LAVAISLANDLEVEL_MAP_TIME
};

extern u8* const level_enemies[LEVEL_COUNT] =
{
    map_IntroLevel_enemies,
    map_SwitchesLevel_enemies,
    map_TeleportersLevel_enemies,
    map_IslandLevel_enemies,
    map_HedgeMazeLevel_enemies,
    map_LavaIslandLevel_enemies
};

extern const u8 level_enemies_array_size[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_ENEMIES_SIZE,
    MAP_SWITCHESLEVEL_ENEMIES_SIZE,
    MAP_TELEPORTERSLEVEL_ENEMIES_SIZE,
    MAP_ISLANDLEVEL_ENEMIES_SIZE,
    MAP_HEDGEMAZELEVEL_ENEMIES_SIZE,
    MAP_LAVAISLANDLEVEL_ENEMIES_SIZE
};

extern const u8 level_palette[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_PALETTE,
    MAP_SWITCHESLEVEL_PALETTE,
    MAP_TELEPORTERSLEVEL_PALETTE,
    MAP_ISLANDLEVEL_PALETTE,
    MAP_HEDGEMAZELEVEL_PALETTE,
    MAP_LAVAISLANDLEVEL_PALETTE
};

extern const u8 level_artefact_piece_count[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_ARTEFACT_PIECE_COUNT,
    MAP_SWITCHESLEVEL_ARTEFACT_PIECE_COUNT,
    MAP_TELEPORTERSLEVEL_ARTEFACT_PIECE_COUNT,
    MAP_ISLANDLEVEL_ARTEFACT_PIECE_COUNT,
    MAP_HEDGEMAZELEVEL_ARTEFACT_PIECE_COUNT,
    MAP_LAVAISLANDLEVEL_ARTEFACT_PIECE_COUNT
};

extern const u8 level_crumble_cell[LEVEL_COUNT] =
{
    MAP_INTROLEVEL_CRUMBLE_CELL,
    MAP_SWITCHESLEVEL_CRUMBLE_CELL,
    MAP_TELEPORTERSLEVEL_CRUMBLE_CELL,
    MAP_ISLANDLEVEL_CRUMBLE_CELL,
    MAP_HEDGEMAZELEVEL_CRUMBLE_CELL,
    MAP_LAVAISLANDLEVEL_CRUMBLE_CELL
};