#ifndef MAPMANAGER_H
#define MAPMANAGER_H

#include <types.h>
#include "GameTypes.h"
#include "maps/IntroLevel.h"
#include "maps/SwitchesLevel.h"
#include "maps/TeleportersLevel.h"
#include "maps/IslandLevel.h"
#include "maps/HedgeMazeLevel.h"
#include "maps/LavaIslandLevel.h"

// Level map array pointers.
extern u8* const level_map[LEVEL_COUNT];

// The size of the map arrays.
extern const u16 level_map_size[LEVEL_COUNT];

// Level link array pointers.
extern u8* const level_links[LEVEL_COUNT];

// The number of elements in the level link array.
extern const u8 level_links_array_size[LEVEL_COUNT];

// Level start position array pointers.
extern u8* const level_start_position[LEVEL_COUNT];

// The default environment cell for the level.
extern const u8 level_default_environment_cell[LEVEL_COUNT];

// The environment cell to use when clearing cells from the level.
extern const u8 level_clear_cell[LEVEL_COUNT];

// The map time for the level.
extern const u8 level_map_time[LEVEL_COUNT];

// Level enemy array pointers.
extern u8* const level_enemies[LEVEL_COUNT];

// The number of elements in the level enemy array.
extern const u8 level_enemies_array_size[LEVEL_COUNT];

// The chosen palette to use for the level.
extern const u8 level_palette[LEVEL_COUNT];

// The number of pieces of artefacts for the level.
extern const u8 level_artefact_piece_count[LEVEL_COUNT];

// The cell value for the end of the crumbling block cycle.
extern const u8 level_crumble_cell[LEVEL_COUNT];

#endif