#ifndef OBJECT_H
#define OBJECT_H

#include "GameTypes.h"

typedef struct Position Position;
typedef struct Object Object;
typedef struct Velocity Velocity;

struct Position
{
    u8 x;
    u8 y;
    u8 room;
};

struct Velocity
{
    i8 x;
    i8 y;
};

struct Object
{
    Position position;
    Position previousPosition;
    Velocity velocity;
};

// Tests if two objects overlap while ignoring velocity.
u8 testObjectIntersection(Object* a, Object* b);

// Tests if two objects overlap while the second object (b) is moving (has velocity).
u8 testObjectIntersectionBVelocity(Object* a, Object* b);

#endif