#include "Palette.h"

u8 greenMode = FALSE;

// Colour palettes.
const u8 sandPalette_[16] = { 0x4, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x16, 0x7, 0xe, 0x17, 0x1e, 0x6, 0x3, HW_BRIGHT_YELLOW, HW_BRIGHT_WHITE };
const u8 naturalPalette_[16] = { 0x4, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x16, 0x2, 0x1e, 0x1a, 0x1c, 0xd, 0x6, HW_BRIGHT_YELLOW, HW_BRIGHT_WHITE };
const u8 lavaPalette_[16] = { 0x4, 0xa, 0x13, 0xc, 0xb, 0x14, 0x15, 0x16, 0x0, 0x7, 0xe, 0x1e, 0x1c, 0x5, HW_BRIGHT_YELLOW, HW_BRIGHT_WHITE };

// Green palettes.
const u8 green_sandPalette_[16] = { HW_BLACK, HW_BRIGHT_WHITE, 0x13, 0xc, 0xb, 0x14, HW_YELLOW, HW_MAUVE, HW_PASTEL_MAGENTA, HW_BRIGHT_CYAN, HW_LIME, HW_BLUE, HW_BRIGHT_MAGENTA, HW_BRIGHT_WHITE, HW_BRIGHT_YELLOW, HW_BRIGHT_WHITE };
const u8 green_naturalPalette_[16] = { HW_BLACK, HW_BRIGHT_WHITE, 0x13, 0xc, 0xb, 0x14, HW_YELLOW, HW_MAUVE, HW_PASTEL_MAGENTA, HW_BRIGHT_YELLOW, 0x1a, 0x1c, 0xd, 0x6, HW_BRIGHT_YELLOW, HW_BRIGHT_WHITE };
const u8 green_lavaPalette_[16] = { HW_BLACK, HW_BRIGHT_WHITE, 0x13, 0xc, 0xb, 0x14, HW_YELLOW, HW_MAUVE, HW_PASTEL_MAGENTA, HW_BRIGHT_YELLOW, 0xe, HW_PURPLE, 0x1c, 0x5, HW_BRIGHT_YELLOW, HW_BRIGHT_WHITE };

// Options for game palette when display on a colour monitor.
u8* const colourPalettes_[3] = { sandPalette_, naturalPalette_, lavaPalette_ };

// Options for game palette when display on a green (GT64) monitor.
u8* const greenPalettes_[3] = { green_sandPalette_, green_naturalPalette_, green_lavaPalette_ };

void updatePalette(u8 palette)
{
    if (greenMode)
    {
        cpct_setPalette(greenPalettes_[palette], 16);
    }
    else
    {
        cpct_setPalette(colourPalettes_[palette], 16);
    }
}