#include "ProjectileState.h"

// The state of the projectiles in the game (holding both player and enemy projectiles).
struct Projectile projectileState[MAX_PROJECTILE_COUNT];

// Array used as a queue to determine which projectiles are currently active in the projectile state.
u8 projectileQueue[MAX_PROJECTILE_COUNT];

void logicProjectiles()
{
    u8 i = 0;
    Projectile* projectile = projectileState;

    for (i = 0; i < MAX_PROJECTILE_COUNT; ++i)
    {
        // The health of the projectile will be checked in logicProjectile().
        logicProjectile(projectile);

        // Move to the next projectile in the projectile state.
        ++projectile;
    }
}

void drawProjectiles()
{
    u8 i = 0;
    Projectile* projectile = projectileState;

    for (i = 0; i < MAX_PROJECTILE_COUNT; ++i)
    {
        // Draw the projectile that has spawned.
        drawProjectile(projectile);

        // Move to the next projectile in the projectile state.
        ++projectile;
    }
}

u8 nextProjectileIndex()
{
    // Start at 1 as 0 is for the player projectile.
    u8 index = 1;

    // Iterate through the entire projectile queue.
    while (index < MAX_PROJECTILE_COUNT)
    {
        // Check if the current queue item is free.
        if (projectileQueue[index] == PROJECTILE_QUEUE_FREE)
        {
            // Queue item is not set so return index.
            return index;
        }
        else
        {
            // Move to the next item in the queue.
            ++index;
        }
    }

    // No items available in the queue.
    return 0;
}