#ifndef PROJECTILESTATE_H
#define PROJECTILESTATE_H

#include "Projectile.h"

// The maximum number of projectiles that can be spawned on the map.
#define MAX_PROJECTILE_COUNT 4

// The index of the player projectile in the projectile state array.
#define PLAYER_PROJECTILE_INDEX 0

// The state of the projectiles in the game (holding both player and enemy projectiles).
extern struct Projectile projectileState[MAX_PROJECTILE_COUNT];

// Array used as a queue to determine which projectiles are currently active in the projectile state.
extern u8 projectileQueue[MAX_PROJECTILE_COUNT];

// Runs the logic for all the projectiles in the projectile state.
void logicProjectiles();

// Draws all the projectiles in the projectile state on screen.
void drawProjectiles();

// The index of the next available projectile in the projectile state.
u8 nextProjectileIndex();

#endif