#ifndef TEXT_H
#define TEXT_H

#include <cpctelera.h>
#include "GameTypes.h"

// The width of a character from the font when drawing on screen.
#define CHARACTER_WIDTH 2

// The height of a character from the font when drawing on screen.
#define CHARACTER_HEIGHT 8

// The offset used for converting a number to ascii for drawing on screen.
#define ASCII_TO_NUMBER_OFFSET 48

// Draws a string at a specified position on screen using the game font.
void drawString(u8 x, u8 y, const u8* string);

// Draws the specified score at the specified position with appropriate zero padding.
void drawScore(u16 score, u8 scoreStartPosition, u8 yPosition);

// Converts a 16 bit number to an equivalent string of characters for printing on screen.
void convertNumberToString(u16 input, u8* output);

// Draw the time remaining in the level at the specified position with appropriate zero padding.
void drawTimeRemaining(u8 time, u8 xPosition, u8 yPosition);

#endif